-------------------------------------
-------- 公共函数放这里 -------------
-------------------------------------
cclog = function(...)
    print(string.format(...))
end

function cclog_error(msg)
    print("------------------error-----------------")
    print("LUA ERROR: "..tostring(msg))
end
--[[
--禁止使用全局变量
setmetatable(_G,
	{
		__newindex = function (t,k,v)
			if type(v) ~= 'function' then
				local info = debug.getinfo(2,"Sl")
				if info ~= nil then -- 一定要检测是否为nil，如果C函数直接调过来Sl是nil！
					cclog_error(info.short_src..", errorline : "..info.currentline)
					cclog_error("error:write to global var "..k)
				end
			else
				rawset(t,k,v)
			end

			end,
		__index = function(t,k)
			if type(k) ~= 'function' then
				local info = debug.getinfo(2,"Sl")
				if info ~= nil then  -- 一定要检测是否为nil，如果C函数直接调过来Sl是nil！
					cclog_error(info.short_src..", errorline : "..info.currentline)
					cclog_error("error: read undefined global var "..k)
				end
			end
		end,
	}
)

--通过这个函数设置一些全局变量
function set_global(k,v)
	rawset(_G,k,v)
end
--]]
function api_call_function(fun_name,...)
	local fun = nil
	if type(fun_name) == "function" then
		fun = fun_name
	elseif type(fun_name) == "string" then
		fun = loadstring("return "..fun_name)()
	else
		fun = nil
	end
	if fun ~= nil and type(fun) == "function" then
		if arg == nil then
			return fun()
		end
		return fun(unpack(arg))
	else
		return cclog("api_call_function fail to call "..tostring(fun_name));
	end
end

function string:split(sep)
	local sep, fields = sep or ":", {}
	local pattern = string.format("([^%s]+)", sep)
	self:gsub(pattern, function(c) fields[#fields+1] = c end)
	return fields
end

-- lua中的表赋值是引用赋值的，有些地方需要拷贝
function api_copy_table(tb_data)
	local tb_new = {}
	for i,v in pairs(tb_data) do
		tb_new[i] = v
	end
	return tb_new
end

----------------------------------------------------------
-- 基本共用界面动画
-- 界面放大显示
function api_action_scale_show(layer)
	layer:setScale(0.1)
	layer:setOpacity(0)
	layer:setVisible(true)
	
	local action1 = CCSpawn:createWithTwoActions(CCScaleTo:create(0.12,1.15),CCFadeTo:create(0.12,255))
	local action  = CCSequence:createWithTwoActions(action1,CCScaleTo:create(0.1,1.0))
	layer:runAction(action)
end
-- 界面缩小隐藏
function api_action_scale_hide(layer)
	layer:setVisible(true)	
	local array = CCArray:create()
	array:addObject(CCScaleTo:create(0.1,1.15))
	array:addObject(CCSpawn:createWithTwoActions(CCScaleTo:create(0.12,0.1),CCFadeTo:create(0.12,0)))
	array:addObject(CCHide:create())
	local action  = CCSequence:create(array)
	layer:runAction(action)
end
-- 界面渐现
function api_action_fade_show(layer)
	layer:setOpacity(0)
	layer:setVisible(true)	
	local action = CCFadeTo:create(0.1,255)
	layer:runAction(action)
end
-- 界面渐隐
function api_action_fade_hide(layer)
	layer:setVisible(true)
	local action  = CCSequence:createWithTwoActions(CCFadeTo:create(0.1,0),CCHide:create())
	layer:runAction(action)
end

-- 界面渐现
function api_action_show(layer)
	layer:setOpacity(0)
	layer:setVisible(true)	
end
-- 界面渐隐
function api_action_hide(layer)
	layer:setVisible(true)
end

function addLayerTouch(layer)
	layer:registerScriptTouchHandler(function(eventType,x,y)if eventType == "began" then return layer:isVisible() end end,false,0,true)
	layer:setTouchEnabled(true)
end 

--执行完一个动画就消失
function doActionDisappear(sc,pic,size,playtime)
	local function onEnd()
		sc:removeFromParentAndCleanup(false);
	end

	local animation = CCAnimation:create()
	for i=1,size do
		animation:addSpriteFrameWithFileName(string.format(pic,i))
	end
	animation:setDelayPerUnit(playtime)
	animation:setRestoreOriginalFrame(true)
	
	local totalTime = playtime*size
	local action2  = CCSequence:createWithTwoActions(CCDelayTime:create(totalTime),CCCallFunc:create(onEnd))
	local actionAll = CCSpawn:createWithTwoActions(CCAnimate:create(animation),action2)
	sc:runAction(actionAll)
end 


function gotoMap(level,flg)
	GameLevel:GetInstance():endLevel()
	--showLoading();
	
	local loadingScen = GameLoadingLayer:create(enGameLoadingType_MAP,level,flg);
	local reScene = CCTransitionFade:create(0.3,loadingScen)
	CCDirector:sharedDirector():replaceScene(reScene)
end

function gotoGame(start_level)
	enterGame()
	local loadingScen = GameLoadingLayer:create(enGameLoadingType_GAME,start_level)
	local reScene = CCTransitionFade:create(0.3,loadingScen)
	CCDirector:sharedDirector():replaceScene(reScene)
end


function loadingAndEnterGame(start_level)
	GameLevel:GetInstance():startLevel(start_level)
	local pGameScene = GameLevel:GetInstance():getGameScene()
	load_game_ui(pGameScene)
	enterGame()
	--切换到游戏的场景中
	local reScene = CCTransitionFade:create(0.3,pGameScene)
	CCDirector:sharedDirector():replaceScene(reScene)
end


function loadingAndEnterMap(start_level,isgo)
	local mapScene;

	if isgo == true then
		mapScene = GameMapScene:create()
		show_go_path(start_level)
	else
		if start_level >0 then
			mapScene = GameMapScene:create(start_level)
		else
			mapScene = GameMapScene:create()
		end

		if start_level == -1 then
			show_next_work(mapScene)
		end
	end

	local reScene = CCTransitionFade:create(0.4,mapScene)
	CCDirector:sharedDirector():replaceScene(reScene)
end


function hiddenLoading(pGameScene)
	--local pGameScene = GameLevel:GetInstance():getGameScene()
	--if pGameScene ==nil then 
		--pGameScene = api_getGameMapScene()
	--end 

	if pGameScene then
		local pBackLayer =  pGameScene:getChildByTagName('loading_layer')
		if pBackLayer then 
			api_action_fade_hide(pBackLayer)
		end
    end
end
	

function showLoading(pGameScene)
	--local pGameScene = GameLevel:GetInstance():getGameScene()
	--if pGameScene ==nil then 
		--pGameScene = api_getGameMapScene()
	--end 

	local screen_size = CCDirector:sharedDirector():getWinSize()
	local pBackLayer =  pGameScene:getChildByTagName('loading_layer')
	
	if pBackLayer then 
		api_action_fade_show(pBackLayer)
		return
	else
		pBackLayer = CCLayerColor:create(ccc4(0,0,0,0))
		pBackLayer:runAction(CCFadeTo:create(0.2,140))
		pGameScene:addChild(pBackLayer,100)
		pBackLayer:setOpacity(-2)
		pBackLayer:setTagName('loading_layer');
	end
	
	local helper = UIUtils:create()
	
	local pUiLayerx = CCLayerRGBA:create()
	pBackLayer:addChild(pUiLayerx,4)
	
	pUiLayerx:registerScriptTouchHandler(function(eventType,x,y)if eventType == "began" then return pUiLayerx:isVisible() end end,false,-1,true)
	pUiLayerx:setTouchEnabled(true)
	


	local loadingBack = CCSprite:create('ui/welcome/back_2.d2')
	local height = 85+25+20+20
	if screen_size.height <= 960 then
		loadingBack = CCSprite:create('ui/welcome/back_1.d2')
	end
	loadingBack:setScaleX(screen_size.width/640);
	loadingBack:setPosition(ccp(screen_size.width/2,screen_size.height/2))
	pUiLayerx:addChild(loadingBack)
	

	local xxLayer = CCLayerColor:create(ccc4(0,0,0,0))
	xxLayer:runAction(CCFadeTo:create(0.12,140))

	pUiLayerx:addChild(xxLayer)
	--pGameScene:addChild(xxLayer,100)

	
	local lineback = helper:getPriteByCache('loading_back.png')
	lineback:setPosition(ccp(screen_size.width/2,screen_size.height/2))
	xxLayer:addChild(lineback)
	
	local helper = UIUtils:create()
	--松鼠奔跑
	local pSprite = helper:getPriteByCache('run_1.png')
	pSprite:setScale(0.6)
	pSprite:setPosition(ccp(80,115))
	lineback:addChild(pSprite)
	
	--奔跑动画
	local anim_config = {pic='run',size=12,list='squirrel/other/run.plist'}
	helper:playAminForEverCache(pSprite,anim_config.pic,anim_config.size,0.1)
	
	local pSprite = helper:getPriteByCache('loading_text.png')
	pSprite:setPosition(ccp(70,55))
	lineback:addChild(pSprite)
	
	local point1 = helper:getPriteByCache('point.png')
	point1:setPosition(ccp(115,55))
	point1:setVisible(false)
	lineback:addChild(point1)
	
	local point2 = helper:getPriteByCache('point.png')
	point2:setPosition(ccp(125,55))
	point2:setVisible(false)
	lineback:addChild(point2)
	
	local point3 = helper:getPriteByCache('point.png')
	point3:setPosition(ccp(135,55))
	point3:setVisible(false)
	lineback:addChild(point3)
	
	local function showNone()
		point1:setVisible(false)
		point2:setVisible(false)
		point3:setVisible(false)
	end 
	
	local function showOne()
		point1:setVisible(true)
		point2:setVisible(false)
		point3:setVisible(false)
	end 
	
	local function showTwo()
		point1:setVisible(true)
		point2:setVisible(true)
		point3:setVisible(false)
	end 
	
	local function showThree()
		point1:setVisible(true)
		point2:setVisible(true)
		point3:setVisible(true)
	end 
	
	local array = CCArray:create()
	array:addObject(CCDelayTime:create(0.3))
	array:addObject(CCCallFunc:create(showNone))
	array:addObject(CCDelayTime:create(0.3))
	array:addObject(CCCallFunc:create(showOne))
	array:addObject(CCDelayTime:create(0.3))
	array:addObject(CCCallFunc:create(showTwo))
	array:addObject(CCDelayTime:create(0.3))
	array:addObject(CCCallFunc:create(showThree))
	local action  = CCSequence:create(array)
	lineback:runAction(CCRepeatForever:create(action))
end


function show_weixin_share(pGameScene,isSucues)
	local helper = UIUtils:create()
	local screen_size = CCDirector:sharedDirector():getWinSize()
	
	local pBackLayer = CCLayerColor:create(ccc4(0,0,0,0))
	pBackLayer:runAction(CCFadeTo:create(0.12,140))
	pGameScene:addChild(pBackLayer,100)
	pBackLayer:setOpacity(-2)
	
	local pUiLayer = CCLayerRGBA:create()
	pGameScene:addChild(pUiLayer,100)
	pUiLayer:setTagName('show_weixin_share')
	
	pUiLayer:registerScriptTouchHandler(function(eventType,x,y)if eventType == "began" then return pUiLayer:isVisible() end end,false,-1,true)
	pUiLayer:setTouchEnabled(true)
		
	local pSpriteBack = helper:getPriteByCache('back_4.png')
	pSpriteBack:setPosition(ccp(screen_size.width/2,screen_size.height/2))
	pUiLayer:addChild(pSpriteBack)
	
	local pSpriteBack = helper:getPriteByCache('back_title.png')
	pSpriteBack:setPosition(ccp(screen_size.width/2,screen_size.height/2+204))
	pUiLayer:addChild(pSpriteBack)
	
	--设置标题
	local pSpriteBack = helper:getPriteByCache('share_title.png')
	pSpriteBack:setPosition(ccp(screen_size.width/2,screen_size.height/2+204))
	pUiLayer:addChild(pSpriteBack)
	
	--关闭按钮
	local pSprite = helper:get9PriteByCache('btn_close.png')
	local pBtn = CCControlButton:create(pSprite)
	pBtn:setPreferredSize(CCSizeMake(66,66))
	
	pBtn:setPosition(ccp(screen_size.width/2+270,screen_size.height/2+194))
	pUiLayer:addChild(pBtn)
	local function onBtnClose()
		api_action_scale_hide(pUiLayer)
		pBackLayer:runAction(CCFadeTo:create(0.3,0))
		playEffects(enSound_CloseBtn,false)

		if isSucues then 
			showLuckdraw(pGameScene)
		end
	end
	pBtn:setTouchPriority(-2)
	pBtn:addHandleOfControlEvent(onBtnClose,CCControlEventTouchUpInside)


	--微信
	local pSprite = helper:get9PriteByCache('share_weixin.png')
	local pBtn = CCControlButton:create(pSprite)
	pBtn:setPreferredSize(CCSizeMake(100,100))
	
	pBtn:setPosition(ccp(screen_size.width/2-100,screen_size.height/2+25))
	pUiLayer:addChild(pBtn)
	local function onBtnClose()
		api_action_scale_hide(pUiLayer)
		pBackLayer:runAction(CCFadeTo:create(0.3,0))
		playEffects(enSound_CloseBtn,false)
		User:GetInstance():showWeixin('水果泡泡龙',getWeiXinContent(),'http://www.appabc.com/popo/100?requestType=SHARE',0);
		if isSucues then 
			showLuckdraw(pGameScene)
		end
	end
	pBtn:setTouchPriority(-2)
	pBtn:addHandleOfControlEvent(onBtnClose,CCControlEventTouchUpInside)

	local pSpriteBack = helper:getPriteByCache('share_weixinz.png')
	pSpriteBack:setPosition(ccp(50,-30))
	pBtn:addChild(pSpriteBack)


	--朋友圈
	local pSprite = helper:get9PriteByCache('share_pyquan.png')
	local pBtn = CCControlButton:create(pSprite)
	pBtn:setPreferredSize(CCSizeMake(100,100))
	
	pBtn:setPosition(ccp(screen_size.width/2+100,screen_size.height/2+25))
	pUiLayer:addChild(pBtn)
	local function onBtnClose()
		api_action_scale_hide(pUiLayer)
		pBackLayer:runAction(CCFadeTo:create(0.3,0))
		playEffects(enSound_CloseBtn,false)
		User:GetInstance():showWeixin('水果泡泡龙',getWeiXinContent(),'http://www.appabc.com/popo/100?requestType=SHARE',1);
		if isSucues then 
			showLuckdraw(pGameScene)
		end
	end
	pBtn:setTouchPriority(-2)
	pBtn:addHandleOfControlEvent(onBtnClose,CCControlEventTouchUpInside)


	local pSpriteBack = helper:getPriteByCache('share_pyquanz.png')
	pSpriteBack:setPosition(ccp(50,-30))
	pBtn:addChild(pSpriteBack)


end


function closeByPay(typex)
    print("------------------closeByPay-----------------")
	if typex == EnumFeeType_MM501 then
		if pcall(showVipBuySuccess) then 
		else 
		end 

	elseif typex == EnumFeeType_MM502 or typex == EnumFeeType_MM505 or typex == EnumFeeType_MM507 then 
		refersh_gameByShop()

		if typex == EnumFeeType_MM507 then
			buyLuckSucces()
		end

	elseif typex == EnumFeeType_MM503 or typex == EnumFeeType_MM504 then 
		updateToys()

	elseif typex == EnumFeeType_MM506 then
		showAddQiuAni()
		shoot_finish()

	elseif typex == EnumFeeType_MM508 then 
		lockBuySuccess()
		return;

	elseif typx == EnumFeeType_MM513 then 

	end



	playEffects(enSound_BuySucess,false)
	local pGameScene = GameLevel:GetInstance():getGameScene()
	if pGameScene ==nil then 
		pGameScene = api_getGameMapScene()
		updateToys()
	else 
		refersh_gameByShop()
	end 
	

	local pBackLayer = pGameScene:getChildByTag(10001);

	if pBackLayer then 
		local pUiLayer = pBackLayer:getChildByTag(10001);
		if pUiLayer then
			api_action_scale_hide(pUiLayer)
		end
		pBackLayer:runAction(CCFadeTo:create(0.3,0))
	end
	--updateToys()

	if typex == EnumFeeType_MM505 then 
		if isGoLevel then 
			gotoMap(isGoLevel)
		end
	end

	if typex == EnumFeeType_MM502 or typex == EnumFeeType_MM504 or typex == EnumFeeType_MM503 or typex == EnumFeeType_MM505 then 
		showBuySucessTip(true);
	end


	if typex == EnumFeeType_MM509 or typex == EnumFeeType_MM510 or typex == EnumFeeType_MM516 then 
		onToolsPaySuccess(typex)
		if typex == EnumFeeType_MM516 then 
			showBuySucessTip(true);
		else 
			showBuySucessTip(false);	
		end 
	end 

	if typex == EnumFeeType_MM513 then 
		showBuySucessTip(false);
	end

	if typex == EnumFeeType_MM518  then 
		func1()
	end 
	if typex == EnumFeeType_MM519 then 
		func2()
	end 
	if typex == EnumFeeType_MM520  then 
		func3()
	end
	if typex == EnumFeeType_MM521  then 
		func4()
	end 
	if typex == EnumFeeType_MM522 then 
		func5()
	end

end


function showSucessWindows(typex)
	if typex == EnumFeeType_MM509 or typex == EnumFeeType_MM510 then 
		showBuySucessTip(false);
	else
		showBuySucessTip(true);
	end 

end 



function showBuySucessTip(isShowD,isWin)

	local helper = UIUtils:create()
	local pGameScene = api_getGameMapScene()
	if pGameScene ==nil then 
		pGameScene = GameLevel:GetInstance():getGameScene()
	end 

	pGameScene:removeChildByTag(10001,true)

	local pColorBack = CCLayerColor:create(ccc4(0,0,0,0))
	pColorBack:runAction(CCFadeTo:create(0.2,140))
	pGameScene:addChild(pColorBack,100)
	pColorBack:setTag(10001)
	pColorBack:setTagName('buy_shop_buy_color')
	
	
	local pUiLayerx = CCLayerRGBA:create()
	pColorBack:addChild(pUiLayerx,1)
	pUiLayerx:setTag(10001)
	pUiLayerx:setTagName('buy_buy_ui')
		
	pUiLayerx:registerScriptTouchHandler(function(eventType,x,y)if eventType == "began" then return pUiLayerx:isVisible() end end,false,-1,true)
	pUiLayerx:setTouchEnabled(true)
	
	local screen_size = CCDirector:sharedDirector():getWinSize()	
	
	--道具的文字提示
	local pSpriteBack = helper:getPriteByCache('diamond_bj.png')
	pSpriteBack:setPosition(ccp(screen_size.width/2,screen_size.height/2))
	pUiLayerx:addChild(pSpriteBack)

	--道具的文字提示
	local pSpriteBack = helper:getPriteByCache('diamond_succeed_title.png')
	pSpriteBack:setPosition(ccp(screen_size.width/2,screen_size.height/2-35))
	pUiLayerx:addChild(pSpriteBack)



	local function exitOK()
		api_action_scale_hide(pUiLayerx)
		pColorBack:runAction(CCFadeTo:create(0.3,0))
	end


	local function showExit()
		--api_action_scale_hide(pUiLayerx)

		-- for i=1,120 do
		-- 	getRandomScprit(pColorBack)
		-- end	
		if isShowD then 
			showDimandJumpAnimats(pUiLayerx,pColorBack,isWin)
		else 
			exitOK()
		end 
	end

	local array = CCArray:create()
	array:addObject(CCDelayTime:create(0.6))
	array:addObject(CCCallFunc:create(showExit))
	--array:addObject(CCDelayTime:create(2.4))
	--array:addObject(CCCallFunc:create(exitOK))
	local action  = CCSequence:create(array)
	pUiLayerx:runAction(action)
	
end


function showDimandJumpAnimats(pUiLayerx,pColorBack,isWin)
	local isExit = false;
	function onExitx()

		if not isExit then
			api_action_scale_hide(pUiLayerx)
			pColorBack:runAction(CCFadeTo:create(0.3,0))
			isExit = true;

			if isWin then 
				load_challenge_succ_ui();
			end 

		end 
	end 


	function onOne()
		
	end

	function playMore()
		local screen_size = CCDirector:sharedDirector():getWinSize()
		local helper = UIUtils:create();
		
		for i=1,20 do

			local jAction = nil
			local leftwidht = screen_size.width/2
			local leftHeight = screen_size.height/2-50+90;
			local dey = 15;
			if isLeft then 

				jAction = CCJumpTo:create(0.8,ccp(screen_size.width/2+50-math.random(450),screen_size.height/2-math.random(350)),350+math.random(100),1)
				isLeft = false;
					--leftwidht = leftwidht-math.random(60)
					--leftHeight = leftHeight+math.random(60)
			else
				jAction = CCJumpTo:create(0.8,ccp(screen_size.width/2-50+math.random(450),screen_size.height/2-math.random(350)),350+math.random(100),1)
				isLeft = true;
				dey = 0 - dey;
					--leftwidht = leftwidht+math.random(60)
					--leftHeight = leftHeight-math.random(60)
			end 

			local days = helper:getPriteByCache('dimand_1.png')
			days:setPosition(ccp(leftwidht,leftHeight))
			days:setVisible(false)
			pUiLayerx:addChild(days) 

			
			local actionArray = CCArray:create()
			actionArray:addObject(CCDelayTime:create(0.1))
			actionArray:addObject(CCShow:create())
			actionArray:addObject(CCSpawn:createWithTwoActions(jAction,CCScaleTo:create(0.8,1.5)))
			actionArray:addObject(CCHide:create())
			local action 	= CCSequence:create(actionArray)
			days:runAction(action)
		end 

	end 


	function doOne()
		local screen_size = CCDirector:sharedDirector():getWinSize()
		local helper = UIUtils:create();
		
		if indexNum > 0 then 
			indexNum = indexNum -1;


			local jAction = nil
			local leftwidht = screen_size.width/2
			local leftHeight = screen_size.height/2-50+90;
			local dey = 15;
			if isLeft then 

				jAction = CCJumpTo:create(0.8,ccp(screen_size.width/2+50-math.random(450),screen_size.height/2-math.random(350)),350+math.random(100),1)
				isLeft = false;
				--leftwidht = leftwidht-math.random(60)
				--leftHeight = leftHeight+math.random(60)
			else
				jAction = CCJumpTo:create(0.8,ccp(screen_size.width/2-50+math.random(450),screen_size.height/2-math.random(350)),350+math.random(100),1)
				isLeft = true;
				dey = 0 - dey;
				--leftwidht = leftwidht+math.random(60)
				--leftHeight = leftHeight-math.random(60)
			end 

			local days = helper:getPriteByCache('dimand_1.png')
			days:setPosition(ccp(leftwidht,leftHeight))
			days:setVisible(false)
			pUiLayerx:addChild(days) 

			local array = CCArray:create()
			array:addObject(CCRotateBy:create(0.3,dey))
			local action  = CCSequence:create(array)
			--days:runAction(CCRepeatForever:create(action))

			
			local actionArray = CCArray:create()
			actionArray:addObject(CCDelayTime:create(0.0001))
			actionArray:addObject(CCCallFunc:create(doOne))
			actionArray:addObject(CCShow:create())
			actionArray:addObject(CCSpawn:createWithTwoActions(jAction,CCScaleTo:create(0.8,1.5)))
			actionArray:addObject(CCHide:create())
			actionArray:addObject(CCCallFunc:create(onOne))
			local action 	= CCSequence:create(actionArray)
			days:runAction(action)
			
		else 
			local array = CCArray:create()
			array:addObject(CCDelayTime:create(0.3))
			array:addObject(CCCallFunc:create(onExitx))
			local action  = CCSequence:create(array)
			pUiLayerx:runAction(action)
		end 
	end

	local isLeft = true;
	indexNum = 20

	local actionArray = CCArray:create()
	actionArray:addObject(CCCallFunc:create(playMore))
	actionArray:addObject(CCDelayTime:create(0.4))
	actionArray:addObject(CCCallFunc:create(playMore))
	actionArray:addObject(CCDelayTime:create(0.4))
	actionArray:addObject(CCCallFunc:create(playMore))
	actionArray:addObject(CCDelayTime:create(0.4))
	actionArray:addObject(CCCallFunc:create(onExitx))
	local action 	= CCSequence:create(actionArray)
	pUiLayerx:runAction(action)


	--doOne()

end

--代码控制颜色
function codeContorlColour(noder,kind) 
    local tint = nil
    if kind == 1 then 
        tint = CCTintBy:create(0.5, -127, -127, -127)
    elseif kind == 2 then 
           tint = CCTintBy:create(0.5, -127, -127, 127)
    elseif kind == 3 then 
           tint = CCTintBy:create(0.5, -127, 127, 127)
    elseif kind == 4 then 
           tint = CCTintBy:create(0.5,  127, 127, 127)
    elseif kind == 5 then 
           tint = CCTintBy:create(0.5,  127, 127, -127)
    elseif kind == 6 then 
           tint = CCTintBy:create(0.5,  127, -127, -127)
    elseif kind == 7 then 
           tint = CCTintBy:create(0.5, -127, -222, 111)
    else 
           tint = CCTintBy:create(0.5, -127, 222, 1)
    end
    local tintBack =tint:reverse()
           noder:runAction(CCRepeatForever:create(CCSequence:createWithTwoActions(tint,tintBack)))
end			

--








